package helper

// PtrFromString возвращает указатель на строку,
// если строка не пуста, иначе возвращает nil.
func PtrFromString(str string) *string {
	if str == "" {
		return nil
	}
	return &str
}

// StringFromPtr возвращает значение строки по указателю,
// если указатель не равен nil, иначе возвращает пустую строку.
func StringFromPtr(str *string) string {
	if str == nil {
		return ""
	}
	return *str
}
