package kafka

import (
	"context"
	"log"

	"github.com/segmentio/kafka-go"
)

// producerWrapper реализует интерфейс Producer.
type producerWrapper struct {
	writer *kafka.Writer
}

func (p *producerWrapper) Write(ctx context.Context, messages ...Message) error {
	return p.writer.WriteMessages(ctx, messages...)
}

func (p *producerWrapper) SendMessage(ctx context.Context, msg *Message) {
	go func() {
		if err := p.writer.WriteMessages(ctx, *msg); err != nil {
			log.Printf("Failed to send message: %v", err)
		}
	}()
}

func (p *producerWrapper) Close() error {
	return p.writer.Close()
}
