// Package productassistant provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/oapi-codegen/oapi-codegen/v2 version v2.4.1 DO NOT EDIT.
package productassistant

import (
	"bytes"
	"compress/gzip"
	"context"
	"encoding/base64"
	"encoding/json"
	"fmt"
	"net/http"
	"net/url"
	"path"
	"strings"
	"time"

	"github.com/getkin/kin-openapi/openapi3"
	"github.com/go-chi/chi/v5"
	"github.com/oapi-codegen/runtime"
	strictnethttp "github.com/oapi-codegen/runtime/strictmiddleware/nethttp"
)

// PostAuthTelegramJSONBody defines parameters for PostAuthTelegram.
type PostAuthTelegramJSONBody struct {
	AuthDate  int     `json:"auth_date"`
	FirstName string  `json:"first_name"`
	Hash      string  `json:"hash"`
	Id        int     `json:"id"`
	LastName  *string `json:"last_name,omitempty"`
	PhotoUrl  *string `json:"photo_url,omitempty"`
	Username  *string `json:"username,omitempty"`
}

// PostFavouritesAddJSONBody defines parameters for PostFavouritesAdd.
type PostFavouritesAddJSONBody struct {
	ProductId string `json:"product_id"`
}

// DeleteFavouritesDeleteParams defines parameters for DeleteFavouritesDelete.
type DeleteFavouritesDeleteParams struct {
	// ProductId ID продукта для удаления из избранного
	ProductId string `form:"product_id" json:"product_id"`
}

// GetFavouritesGetParams defines parameters for GetFavouritesGet.
type GetFavouritesGetParams struct {
	// ProductId ID продукта
	ProductId string `form:"product_id" json:"product_id"`
}

// GetGetAbstractProductParams defines parameters for GetGetAbstractProduct.
type GetGetAbstractProductParams struct {
	// Id ID абстрактного товара (UUID)
	Id string `form:"id" json:"id"`
}

// GetGetParsedProductsParams defines parameters for GetGetParsedProducts.
type GetGetParsedProductsParams struct {
	// AbstractId ID абстрактного товара (UUID)
	AbstractId string `form:"abstractId" json:"abstractId"`
}

// PostLlmRequestJSONBody defines parameters for PostLlmRequest.
type PostLlmRequestJSONBody struct {
	// Query Пользовательский запрос.
	Query string `json:"query"`
}

// PostPriceChangeJSONBody defines parameters for PostPriceChange.
type PostPriceChangeJSONBody struct {
	// MarketName (Опционально) Название магазина, где изменилась цена.
	MarketName *string `json:"marketName,omitempty"`

	// NewPrice Новая цена товара.
	NewPrice int `json:"newPrice"`

	// OldPrice Старая цена товара.
	OldPrice int `json:"oldPrice"`

	// ProductId Идентификатор абстрактного продукта.
	ProductId string `json:"productId"`
}

// PostAuthTelegramJSONRequestBody defines body for PostAuthTelegram for application/json ContentType.
type PostAuthTelegramJSONRequestBody PostAuthTelegramJSONBody

// PostFavouritesAddJSONRequestBody defines body for PostFavouritesAdd for application/json ContentType.
type PostFavouritesAddJSONRequestBody PostFavouritesAddJSONBody

// PostLlmRequestJSONRequestBody defines body for PostLlmRequest for application/json ContentType.
type PostLlmRequestJSONRequestBody PostLlmRequestJSONBody

// PostPriceChangeJSONRequestBody defines body for PostPriceChange for application/json ContentType.
type PostPriceChangeJSONRequestBody PostPriceChangeJSONBody

// ServerInterface represents all server handlers.
type ServerInterface interface {
	// Авторизация через Telegram
	// (POST /auth/telegram)
	PostAuthTelegram(w http.ResponseWriter, r *http.Request)
	// Добавить продукт в избранное
	// (POST /favourites/add)
	PostFavouritesAdd(w http.ResponseWriter, r *http.Request)
	// Удалить продукт из избранного
	// (DELETE /favourites/delete)
	DeleteFavouritesDelete(w http.ResponseWriter, r *http.Request, params DeleteFavouritesDeleteParams)
	// Получить избранный продукт
	// (GET /favourites/get)
	GetFavouritesGet(w http.ResponseWriter, r *http.Request, params GetFavouritesGetParams)
	// Получить список избранных продуктов
	// (GET /favourites/list)
	GetFavouritesList(w http.ResponseWriter, r *http.Request)
	// Получить информацию об абстрактном товаре по ID
	// (GET /get-abstract-product)
	GetGetAbstractProduct(w http.ResponseWriter, r *http.Request, params GetGetAbstractProductParams)
	// Получить список парсенных вариантов товара по ID абстрактного товара
	// (GET /get-parsed-products)
	GetGetParsedProducts(w http.ResponseWriter, r *http.Request, params GetGetParsedProductsParams)
	// Запрос к LLM для подбора товаров
	// (POST /llm-request)
	PostLlmRequest(w http.ResponseWriter, r *http.Request)
	// Публикация уведомления об изменении цены
	// (POST /price-change)
	PostPriceChange(w http.ResponseWriter, r *http.Request)
}

// Unimplemented server implementation that returns http.StatusNotImplemented for each endpoint.

type Unimplemented struct{}

// Авторизация через Telegram
// (POST /auth/telegram)
func (_ Unimplemented) PostAuthTelegram(w http.ResponseWriter, r *http.Request) {
	w.WriteHeader(http.StatusNotImplemented)
}

// Добавить продукт в избранное
// (POST /favourites/add)
func (_ Unimplemented) PostFavouritesAdd(w http.ResponseWriter, r *http.Request) {
	w.WriteHeader(http.StatusNotImplemented)
}

// Удалить продукт из избранного
// (DELETE /favourites/delete)
func (_ Unimplemented) DeleteFavouritesDelete(w http.ResponseWriter, r *http.Request, params DeleteFavouritesDeleteParams) {
	w.WriteHeader(http.StatusNotImplemented)
}

// Получить избранный продукт
// (GET /favourites/get)
func (_ Unimplemented) GetFavouritesGet(w http.ResponseWriter, r *http.Request, params GetFavouritesGetParams) {
	w.WriteHeader(http.StatusNotImplemented)
}

// Получить список избранных продуктов
// (GET /favourites/list)
func (_ Unimplemented) GetFavouritesList(w http.ResponseWriter, r *http.Request) {
	w.WriteHeader(http.StatusNotImplemented)
}

// Получить информацию об абстрактном товаре по ID
// (GET /get-abstract-product)
func (_ Unimplemented) GetGetAbstractProduct(w http.ResponseWriter, r *http.Request, params GetGetAbstractProductParams) {
	w.WriteHeader(http.StatusNotImplemented)
}

// Получить список парсенных вариантов товара по ID абстрактного товара
// (GET /get-parsed-products)
func (_ Unimplemented) GetGetParsedProducts(w http.ResponseWriter, r *http.Request, params GetGetParsedProductsParams) {
	w.WriteHeader(http.StatusNotImplemented)
}

// Запрос к LLM для подбора товаров
// (POST /llm-request)
func (_ Unimplemented) PostLlmRequest(w http.ResponseWriter, r *http.Request) {
	w.WriteHeader(http.StatusNotImplemented)
}

// Публикация уведомления об изменении цены
// (POST /price-change)
func (_ Unimplemented) PostPriceChange(w http.ResponseWriter, r *http.Request) {
	w.WriteHeader(http.StatusNotImplemented)
}

// ServerInterfaceWrapper converts contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler            ServerInterface
	HandlerMiddlewares []MiddlewareFunc
	ErrorHandlerFunc   func(w http.ResponseWriter, r *http.Request, err error)
}

type MiddlewareFunc func(http.Handler) http.Handler

// PostAuthTelegram operation middleware
func (siw *ServerInterfaceWrapper) PostAuthTelegram(w http.ResponseWriter, r *http.Request) {

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.PostAuthTelegram(w, r)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r)
}

// PostFavouritesAdd operation middleware
func (siw *ServerInterfaceWrapper) PostFavouritesAdd(w http.ResponseWriter, r *http.Request) {

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.PostFavouritesAdd(w, r)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r)
}

// DeleteFavouritesDelete operation middleware
func (siw *ServerInterfaceWrapper) DeleteFavouritesDelete(w http.ResponseWriter, r *http.Request) {

	var err error

	// Parameter object where we will unmarshal all parameters from the context
	var params DeleteFavouritesDeleteParams

	// ------------- Required query parameter "product_id" -------------

	if paramValue := r.URL.Query().Get("product_id"); paramValue != "" {

	} else {
		siw.ErrorHandlerFunc(w, r, &RequiredParamError{ParamName: "product_id"})
		return
	}

	err = runtime.BindQueryParameter("form", true, true, "product_id", r.URL.Query(), &params.ProductId)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "product_id", Err: err})
		return
	}

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.DeleteFavouritesDelete(w, r, params)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r)
}

// GetFavouritesGet operation middleware
func (siw *ServerInterfaceWrapper) GetFavouritesGet(w http.ResponseWriter, r *http.Request) {

	var err error

	// Parameter object where we will unmarshal all parameters from the context
	var params GetFavouritesGetParams

	// ------------- Required query parameter "product_id" -------------

	if paramValue := r.URL.Query().Get("product_id"); paramValue != "" {

	} else {
		siw.ErrorHandlerFunc(w, r, &RequiredParamError{ParamName: "product_id"})
		return
	}

	err = runtime.BindQueryParameter("form", true, true, "product_id", r.URL.Query(), &params.ProductId)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "product_id", Err: err})
		return
	}

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.GetFavouritesGet(w, r, params)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r)
}

// GetFavouritesList operation middleware
func (siw *ServerInterfaceWrapper) GetFavouritesList(w http.ResponseWriter, r *http.Request) {

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.GetFavouritesList(w, r)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r)
}

// GetGetAbstractProduct operation middleware
func (siw *ServerInterfaceWrapper) GetGetAbstractProduct(w http.ResponseWriter, r *http.Request) {

	var err error

	// Parameter object where we will unmarshal all parameters from the context
	var params GetGetAbstractProductParams

	// ------------- Required query parameter "id" -------------

	if paramValue := r.URL.Query().Get("id"); paramValue != "" {

	} else {
		siw.ErrorHandlerFunc(w, r, &RequiredParamError{ParamName: "id"})
		return
	}

	err = runtime.BindQueryParameter("form", true, true, "id", r.URL.Query(), &params.Id)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "id", Err: err})
		return
	}

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.GetGetAbstractProduct(w, r, params)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r)
}

// GetGetParsedProducts operation middleware
func (siw *ServerInterfaceWrapper) GetGetParsedProducts(w http.ResponseWriter, r *http.Request) {

	var err error

	// Parameter object where we will unmarshal all parameters from the context
	var params GetGetParsedProductsParams

	// ------------- Required query parameter "abstractId" -------------

	if paramValue := r.URL.Query().Get("abstractId"); paramValue != "" {

	} else {
		siw.ErrorHandlerFunc(w, r, &RequiredParamError{ParamName: "abstractId"})
		return
	}

	err = runtime.BindQueryParameter("form", true, true, "abstractId", r.URL.Query(), &params.AbstractId)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "abstractId", Err: err})
		return
	}

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.GetGetParsedProducts(w, r, params)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r)
}

// PostLlmRequest operation middleware
func (siw *ServerInterfaceWrapper) PostLlmRequest(w http.ResponseWriter, r *http.Request) {

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.PostLlmRequest(w, r)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r)
}

// PostPriceChange operation middleware
func (siw *ServerInterfaceWrapper) PostPriceChange(w http.ResponseWriter, r *http.Request) {

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.PostPriceChange(w, r)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r)
}

type UnescapedCookieParamError struct {
	ParamName string
	Err       error
}

func (e *UnescapedCookieParamError) Error() string {
	return fmt.Sprintf("error unescaping cookie parameter '%s'", e.ParamName)
}

func (e *UnescapedCookieParamError) Unwrap() error {
	return e.Err
}

type UnmarshalingParamError struct {
	ParamName string
	Err       error
}

func (e *UnmarshalingParamError) Error() string {
	return fmt.Sprintf("Error unmarshaling parameter %s as JSON: %s", e.ParamName, e.Err.Error())
}

func (e *UnmarshalingParamError) Unwrap() error {
	return e.Err
}

type RequiredParamError struct {
	ParamName string
}

func (e *RequiredParamError) Error() string {
	return fmt.Sprintf("Query argument %s is required, but not found", e.ParamName)
}

type RequiredHeaderError struct {
	ParamName string
	Err       error
}

func (e *RequiredHeaderError) Error() string {
	return fmt.Sprintf("Header parameter %s is required, but not found", e.ParamName)
}

func (e *RequiredHeaderError) Unwrap() error {
	return e.Err
}

type InvalidParamFormatError struct {
	ParamName string
	Err       error
}

func (e *InvalidParamFormatError) Error() string {
	return fmt.Sprintf("Invalid format for parameter %s: %s", e.ParamName, e.Err.Error())
}

func (e *InvalidParamFormatError) Unwrap() error {
	return e.Err
}

type TooManyValuesForParamError struct {
	ParamName string
	Count     int
}

func (e *TooManyValuesForParamError) Error() string {
	return fmt.Sprintf("Expected one value for %s, got %d", e.ParamName, e.Count)
}

// Handler creates http.Handler with routing matching OpenAPI spec.
func Handler(si ServerInterface) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{})
}

type ChiServerOptions struct {
	BaseURL          string
	BaseRouter       chi.Router
	Middlewares      []MiddlewareFunc
	ErrorHandlerFunc func(w http.ResponseWriter, r *http.Request, err error)
}

// HandlerFromMux creates http.Handler with routing matching OpenAPI spec based on the provided mux.
func HandlerFromMux(si ServerInterface, r chi.Router) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{
		BaseRouter: r,
	})
}

func HandlerFromMuxWithBaseURL(si ServerInterface, r chi.Router, baseURL string) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{
		BaseURL:    baseURL,
		BaseRouter: r,
	})
}

// HandlerWithOptions creates http.Handler with additional options
func HandlerWithOptions(si ServerInterface, options ChiServerOptions) http.Handler {
	r := options.BaseRouter

	if r == nil {
		r = chi.NewRouter()
	}
	if options.ErrorHandlerFunc == nil {
		options.ErrorHandlerFunc = func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusBadRequest)
		}
	}
	wrapper := ServerInterfaceWrapper{
		Handler:            si,
		HandlerMiddlewares: options.Middlewares,
		ErrorHandlerFunc:   options.ErrorHandlerFunc,
	}

	r.Group(func(r chi.Router) {
		r.Post(options.BaseURL+"/auth/telegram", wrapper.PostAuthTelegram)
	})
	r.Group(func(r chi.Router) {
		r.Post(options.BaseURL+"/favourites/add", wrapper.PostFavouritesAdd)
	})
	r.Group(func(r chi.Router) {
		r.Delete(options.BaseURL+"/favourites/delete", wrapper.DeleteFavouritesDelete)
	})
	r.Group(func(r chi.Router) {
		r.Get(options.BaseURL+"/favourites/get", wrapper.GetFavouritesGet)
	})
	r.Group(func(r chi.Router) {
		r.Get(options.BaseURL+"/favourites/list", wrapper.GetFavouritesList)
	})
	r.Group(func(r chi.Router) {
		r.Get(options.BaseURL+"/get-abstract-product", wrapper.GetGetAbstractProduct)
	})
	r.Group(func(r chi.Router) {
		r.Get(options.BaseURL+"/get-parsed-products", wrapper.GetGetParsedProducts)
	})
	r.Group(func(r chi.Router) {
		r.Post(options.BaseURL+"/llm-request", wrapper.PostLlmRequest)
	})
	r.Group(func(r chi.Router) {
		r.Post(options.BaseURL+"/price-change", wrapper.PostPriceChange)
	})

	return r
}

type PostAuthTelegramRequestObject struct {
	Body *PostAuthTelegramJSONRequestBody
}

type PostAuthTelegramResponseObject interface {
	VisitPostAuthTelegramResponse(w http.ResponseWriter) error
}

type PostAuthTelegram200JSONResponse struct {
	Message *string `json:"message,omitempty"`
	Token   *string `json:"token,omitempty"`
}

func (response PostAuthTelegram200JSONResponse) VisitPostAuthTelegramResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(200)

	return json.NewEncoder(w).Encode(response)
}

type PostAuthTelegram400Response struct {
}

func (response PostAuthTelegram400Response) VisitPostAuthTelegramResponse(w http.ResponseWriter) error {
	w.WriteHeader(400)
	return nil
}

type PostFavouritesAddRequestObject struct {
	Body *PostFavouritesAddJSONRequestBody
}

type PostFavouritesAddResponseObject interface {
	VisitPostFavouritesAddResponse(w http.ResponseWriter) error
}

type PostFavouritesAdd200JSONResponse struct {
	Message *string `json:"message,omitempty"`
}

func (response PostFavouritesAdd200JSONResponse) VisitPostFavouritesAddResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(200)

	return json.NewEncoder(w).Encode(response)
}

type PostFavouritesAdd400Response struct {
}

func (response PostFavouritesAdd400Response) VisitPostFavouritesAddResponse(w http.ResponseWriter) error {
	w.WriteHeader(400)
	return nil
}

type DeleteFavouritesDeleteRequestObject struct {
	Params DeleteFavouritesDeleteParams
}

type DeleteFavouritesDeleteResponseObject interface {
	VisitDeleteFavouritesDeleteResponse(w http.ResponseWriter) error
}

type DeleteFavouritesDelete200JSONResponse struct {
	Message *string `json:"message,omitempty"`
}

func (response DeleteFavouritesDelete200JSONResponse) VisitDeleteFavouritesDeleteResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(200)

	return json.NewEncoder(w).Encode(response)
}

type GetFavouritesGetRequestObject struct {
	Params GetFavouritesGetParams
}

type GetFavouritesGetResponseObject interface {
	VisitGetFavouritesGetResponse(w http.ResponseWriter) error
}

type GetFavouritesGet200JSONResponse struct {
	Product *struct {
		Content *map[string]interface{} `json:"content,omitempty"`
		Id      *string                 `json:"id,omitempty"`
		Name    *string                 `json:"name,omitempty"`
		Photos  *[]string               `json:"photos,omitempty"`
		Prices  *[]struct {
			Market *string  `json:"market,omitempty"`
			Price  *float32 `json:"price,omitempty"`
			Url    *string  `json:"url,omitempty"`
		} `json:"prices,omitempty"`
	} `json:"product,omitempty"`
}

func (response GetFavouritesGet200JSONResponse) VisitGetFavouritesGetResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(200)

	return json.NewEncoder(w).Encode(response)
}

type GetFavouritesGet400Response struct {
}

func (response GetFavouritesGet400Response) VisitGetFavouritesGetResponse(w http.ResponseWriter) error {
	w.WriteHeader(400)
	return nil
}

type GetFavouritesListRequestObject struct {
}

type GetFavouritesListResponseObject interface {
	VisitGetFavouritesListResponse(w http.ResponseWriter) error
}

type GetFavouritesList200JSONResponse struct {
	Favourites *[]struct {
		Content *map[string]interface{} `json:"content,omitempty"`
		Id      *string                 `json:"id,omitempty"`
		Name    *string                 `json:"name,omitempty"`
		Photos  *[]string               `json:"photos,omitempty"`
		Prices  *[]struct {
			Market *string  `json:"market,omitempty"`
			Price  *float32 `json:"price,omitempty"`
			Url    *string  `json:"url,omitempty"`
		} `json:"prices,omitempty"`
	} `json:"favourites,omitempty"`
}

func (response GetFavouritesList200JSONResponse) VisitGetFavouritesListResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(200)

	return json.NewEncoder(w).Encode(response)
}

type GetFavouritesList400Response struct {
}

func (response GetFavouritesList400Response) VisitGetFavouritesListResponse(w http.ResponseWriter) error {
	w.WriteHeader(400)
	return nil
}

type GetGetAbstractProductRequestObject struct {
	Params GetGetAbstractProductParams
}

type GetGetAbstractProductResponseObject interface {
	VisitGetGetAbstractProductResponse(w http.ResponseWriter) error
}

type GetGetAbstractProduct200JSONResponse struct {
	Product *struct {
		Content   *map[string]interface{} `json:"content,omitempty"`
		CreatedAt *time.Time              `json:"created_at,omitempty"`
		Id        *string                 `json:"id,omitempty"`
		Name      *string                 `json:"name,omitempty"`
		UpdatedAt *time.Time              `json:"updated_at,omitempty"`
	} `json:"product,omitempty"`
}

func (response GetGetAbstractProduct200JSONResponse) VisitGetGetAbstractProductResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(200)

	return json.NewEncoder(w).Encode(response)
}

type GetGetAbstractProduct400Response struct {
}

func (response GetGetAbstractProduct400Response) VisitGetGetAbstractProductResponse(w http.ResponseWriter) error {
	w.WriteHeader(400)
	return nil
}

type GetGetParsedProductsRequestObject struct {
	Params GetGetParsedProductsParams
}

type GetGetParsedProductsResponseObject interface {
	VisitGetGetParsedProductsResponse(w http.ResponseWriter) error
}

type GetGetParsedProducts200JSONResponse struct {
	ParsedProducts *[]struct {
		Id     *string `json:"id,omitempty"`
		Market *string `json:"market,omitempty"`

		// PhotoUrls Список фоток.
		PhotoUrl   *[]string `json:"photo_url,omitempty"`
		Price      *float64  `json:"price,omitempty"`
		ProductUrl *string   `json:"product_url,omitempty"`
	} `json:"parsedProducts,omitempty"`
}

func (response GetGetParsedProducts200JSONResponse) VisitGetGetParsedProductsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(200)

	return json.NewEncoder(w).Encode(response)
}

type GetGetParsedProducts400Response struct {
}

func (response GetGetParsedProducts400Response) VisitGetGetParsedProductsResponse(w http.ResponseWriter) error {
	w.WriteHeader(400)
	return nil
}

type PostLlmRequestRequestObject struct {
	Body *PostLlmRequestJSONRequestBody
}

type PostLlmRequestResponseObject interface {
	VisitPostLlmRequestResponse(w http.ResponseWriter) error
}

type PostLlmRequest200JSONResponse struct {
	// Comment Комментарий, сгенерированный нейронкой.
	Comment *string `json:"comment,omitempty"`

	// Products Список абстрактных товаров.
	Products *[]struct {
		// Content Характеристики товара в формате JSON.
		Content *map[string]interface{} `json:"content,omitempty"`

		// CreatedAt Дата создания товара.
		CreatedAt *time.Time `json:"created_at,omitempty"`

		// Id UUID абстрактного товара.
		Id *string `json:"id,omitempty"`

		// MinPrice Минимальная цена товара.
		MinPrice *float64 `json:"min_price,omitempty"`

		// Name Наименование товара.
		Name *string `json:"name,omitempty"`

		// PhotoUrls Ссылка на фото товара.
		PhotoUrl *string `json:"photo_url,omitempty"`

		// UpdatedAt Дата последнего обновления товара.
		UpdatedAt *time.Time `json:"updated_at,omitempty"`
	} `json:"products,omitempty"`
}

func (response PostLlmRequest200JSONResponse) VisitPostLlmRequestResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(200)

	return json.NewEncoder(w).Encode(response)
}

type PostLlmRequest400Response struct {
}

func (response PostLlmRequest400Response) VisitPostLlmRequestResponse(w http.ResponseWriter) error {
	w.WriteHeader(400)
	return nil
}

type PostPriceChangeRequestObject struct {
	Body *PostPriceChangeJSONRequestBody
}

type PostPriceChangeResponseObject interface {
	VisitPostPriceChangeResponse(w http.ResponseWriter) error
}

type PostPriceChange200JSONResponse struct {
	Message *string `json:"message,omitempty"`
}

func (response PostPriceChange200JSONResponse) VisitPostPriceChangeResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(200)

	return json.NewEncoder(w).Encode(response)
}

type PostPriceChange400Response struct {
}

func (response PostPriceChange400Response) VisitPostPriceChangeResponse(w http.ResponseWriter) error {
	w.WriteHeader(400)
	return nil
}

type PostPriceChange500Response struct {
}

func (response PostPriceChange500Response) VisitPostPriceChangeResponse(w http.ResponseWriter) error {
	w.WriteHeader(500)
	return nil
}

// StrictServerInterface represents all server handlers.
type StrictServerInterface interface {
	// Авторизация через Telegram
	// (POST /auth/telegram)
	PostAuthTelegram(ctx context.Context, request PostAuthTelegramRequestObject) (PostAuthTelegramResponseObject, error)
	// Добавить продукт в избранное
	// (POST /favourites/add)
	PostFavouritesAdd(ctx context.Context, request PostFavouritesAddRequestObject) (PostFavouritesAddResponseObject, error)
	// Удалить продукт из избранного
	// (DELETE /favourites/delete)
	DeleteFavouritesDelete(ctx context.Context, request DeleteFavouritesDeleteRequestObject) (DeleteFavouritesDeleteResponseObject, error)
	// Получить избранный продукт
	// (GET /favourites/get)
	GetFavouritesGet(ctx context.Context, request GetFavouritesGetRequestObject) (GetFavouritesGetResponseObject, error)
	// Получить список избранных продуктов
	// (GET /favourites/list)
	GetFavouritesList(ctx context.Context, request GetFavouritesListRequestObject) (GetFavouritesListResponseObject, error)
	// Получить информацию об абстрактном товаре по ID
	// (GET /get-abstract-product)
	GetGetAbstractProduct(ctx context.Context, request GetGetAbstractProductRequestObject) (GetGetAbstractProductResponseObject, error)
	// Получить список парсенных вариантов товара по ID абстрактного товара
	// (GET /get-parsed-products)
	GetGetParsedProducts(ctx context.Context, request GetGetParsedProductsRequestObject) (GetGetParsedProductsResponseObject, error)
	// Запрос к LLM для подбора товаров
	// (POST /llm-request)
	PostLlmRequest(ctx context.Context, request PostLlmRequestRequestObject) (PostLlmRequestResponseObject, error)
	// Публикация уведомления об изменении цены
	// (POST /price-change)
	PostPriceChange(ctx context.Context, request PostPriceChangeRequestObject) (PostPriceChangeResponseObject, error)
}

type StrictHandlerFunc = strictnethttp.StrictHTTPHandlerFunc
type StrictMiddlewareFunc = strictnethttp.StrictHTTPMiddlewareFunc

type StrictHTTPServerOptions struct {
	RequestErrorHandlerFunc  func(w http.ResponseWriter, r *http.Request, err error)
	ResponseErrorHandlerFunc func(w http.ResponseWriter, r *http.Request, err error)
}

func NewStrictHandler(ssi StrictServerInterface, middlewares []StrictMiddlewareFunc) ServerInterface {
	return &strictHandler{ssi: ssi, middlewares: middlewares, options: StrictHTTPServerOptions{
		RequestErrorHandlerFunc: func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusBadRequest)
		},
		ResponseErrorHandlerFunc: func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusInternalServerError)
		},
	}}
}

func NewStrictHandlerWithOptions(ssi StrictServerInterface, middlewares []StrictMiddlewareFunc, options StrictHTTPServerOptions) ServerInterface {
	return &strictHandler{ssi: ssi, middlewares: middlewares, options: options}
}

type strictHandler struct {
	ssi         StrictServerInterface
	middlewares []StrictMiddlewareFunc
	options     StrictHTTPServerOptions
}

// PostAuthTelegram operation middleware
func (sh *strictHandler) PostAuthTelegram(w http.ResponseWriter, r *http.Request) {
	var request PostAuthTelegramRequestObject

	var body PostAuthTelegramJSONRequestBody
	if err := json.NewDecoder(r.Body).Decode(&body); err != nil {
		sh.options.RequestErrorHandlerFunc(w, r, fmt.Errorf("can't decode JSON body: %w", err))
		return
	}
	request.Body = &body

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.PostAuthTelegram(ctx, request.(PostAuthTelegramRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "PostAuthTelegram")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(PostAuthTelegramResponseObject); ok {
		if err := validResponse.VisitPostAuthTelegramResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// PostFavouritesAdd operation middleware
func (sh *strictHandler) PostFavouritesAdd(w http.ResponseWriter, r *http.Request) {
	var request PostFavouritesAddRequestObject

	var body PostFavouritesAddJSONRequestBody
	if err := json.NewDecoder(r.Body).Decode(&body); err != nil {
		sh.options.RequestErrorHandlerFunc(w, r, fmt.Errorf("can't decode JSON body: %w", err))
		return
	}
	request.Body = &body

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.PostFavouritesAdd(ctx, request.(PostFavouritesAddRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "PostFavouritesAdd")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(PostFavouritesAddResponseObject); ok {
		if err := validResponse.VisitPostFavouritesAddResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// DeleteFavouritesDelete operation middleware
func (sh *strictHandler) DeleteFavouritesDelete(w http.ResponseWriter, r *http.Request, params DeleteFavouritesDeleteParams) {
	var request DeleteFavouritesDeleteRequestObject

	request.Params = params

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.DeleteFavouritesDelete(ctx, request.(DeleteFavouritesDeleteRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "DeleteFavouritesDelete")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(DeleteFavouritesDeleteResponseObject); ok {
		if err := validResponse.VisitDeleteFavouritesDeleteResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// GetFavouritesGet operation middleware
func (sh *strictHandler) GetFavouritesGet(w http.ResponseWriter, r *http.Request, params GetFavouritesGetParams) {
	var request GetFavouritesGetRequestObject

	request.Params = params

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.GetFavouritesGet(ctx, request.(GetFavouritesGetRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "GetFavouritesGet")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(GetFavouritesGetResponseObject); ok {
		if err := validResponse.VisitGetFavouritesGetResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// GetFavouritesList operation middleware
func (sh *strictHandler) GetFavouritesList(w http.ResponseWriter, r *http.Request) {
	var request GetFavouritesListRequestObject

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.GetFavouritesList(ctx, request.(GetFavouritesListRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "GetFavouritesList")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(GetFavouritesListResponseObject); ok {
		if err := validResponse.VisitGetFavouritesListResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// GetGetAbstractProduct operation middleware
func (sh *strictHandler) GetGetAbstractProduct(w http.ResponseWriter, r *http.Request, params GetGetAbstractProductParams) {
	var request GetGetAbstractProductRequestObject

	request.Params = params

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.GetGetAbstractProduct(ctx, request.(GetGetAbstractProductRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "GetGetAbstractProduct")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(GetGetAbstractProductResponseObject); ok {
		if err := validResponse.VisitGetGetAbstractProductResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// GetGetParsedProducts operation middleware
func (sh *strictHandler) GetGetParsedProducts(w http.ResponseWriter, r *http.Request, params GetGetParsedProductsParams) {
	var request GetGetParsedProductsRequestObject

	request.Params = params

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.GetGetParsedProducts(ctx, request.(GetGetParsedProductsRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "GetGetParsedProducts")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(GetGetParsedProductsResponseObject); ok {
		if err := validResponse.VisitGetGetParsedProductsResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// PostLlmRequest operation middleware
func (sh *strictHandler) PostLlmRequest(w http.ResponseWriter, r *http.Request) {
	var request PostLlmRequestRequestObject

	var body PostLlmRequestJSONRequestBody
	if err := json.NewDecoder(r.Body).Decode(&body); err != nil {
		sh.options.RequestErrorHandlerFunc(w, r, fmt.Errorf("can't decode JSON body: %w", err))
		return
	}
	request.Body = &body

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.PostLlmRequest(ctx, request.(PostLlmRequestRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "PostLlmRequest")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(PostLlmRequestResponseObject); ok {
		if err := validResponse.VisitPostLlmRequestResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// PostPriceChange operation middleware
func (sh *strictHandler) PostPriceChange(w http.ResponseWriter, r *http.Request) {
	var request PostPriceChangeRequestObject

	var body PostPriceChangeJSONRequestBody
	if err := json.NewDecoder(r.Body).Decode(&body); err != nil {
		sh.options.RequestErrorHandlerFunc(w, r, fmt.Errorf("can't decode JSON body: %w", err))
		return
	}
	request.Body = &body

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.PostPriceChange(ctx, request.(PostPriceChangeRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "PostPriceChange")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(PostPriceChangeResponseObject); ok {
		if err := validResponse.VisitPostPriceChangeResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+xZS2/bRhD+KwRPCSDL7uvim1ujgQs3NdrmFAQGLa4tJiKpkKsURmDAktMkgIOmLQK0",
	"KJqkQdA7/SBMyxH1F2b/UTGzpLXiy1IipynQky1yd+f1zTezw/u65Wy6+uJ9nVu8xfRFfc1zzU6Da0u+",
	"b/nccLi2tLai1/R7zPMt19EX9Y/qC/pOTXfbzDHalr6of1JfqC/oNb1t8KaPZ80bHd6c56zFtjzDxidt",
	"1+f4120zz+CW66yYKMv1+VKHN79PV9Z0j93tMJ9/7prbuL7hOpw5tNVot1tWgzbP3/ZRk/u632gy2yAB",
	"Hh7NLUYKoPx10+CMLNtuo2GWw9kW81D1Tcvz+bpj2Op7n3uWs4Wvm4bfLHxhmcXntYyq49pNl7vrHa9V",
	"+LbjM69k6450h+UxU1+8idLHVK8pZiZK36qlZ7gbt1mD6zvjh3Cvw+iB33YdX/rq44WFd/C0zXzf2Co2",
	"nLt3mFNsV4GWJvMbntXmEmTwWnRhCKF4DAMIxFMNAjgUPYjFLkRwAoF4CJF4imI+lQZk9r8QjyGCA+hD",
	"ULgXIlLE79i24W3jjp+LBGjiEYRiF0I40c5hihvnN417bsezOPPnDdOsBvmX52uXTHNmKG/LVF0fg2UJ",
	"eJS1HxJIJoLCS7ELMRyLPeiLngbHEMMBhhTOIISBBocaRexA7EIAAxhADGE5MJ5DCIcU04HYh1MNYw1D",
	"FCG6WUg8OxcViZ54osl1I1WKJWfQYbIWk0w0+m8cIsv0fAQS+ZsY1TNsxpnn64s3s5asLGf0QaQfwxmC",
	"dg+OIZD+IRSjmnldjyDWa7qFh93tMG9br+mSilS4ZKFRU8KcjeatDxc2qUvELwiZUndkAPA68WNx+CtP",
	"USGwxcj45M948K8xhR6uMf4WYf+Qg5gokX+hnJeJZabQjgpKdYmlUy3ObL+4GskHhucZ27THsxpsfE8G",
	"foZ3h/FiebhXeeN07A3ZChSX+Txes/oUIHoSjD+TsBP7EBYiMQ+VmfDiS4jhTOyJR2lijImW28cE5zKi",
	"ZfkTpsQqrpwpJEdqVET/f3hWw3MCAOfh+gqGEIkuxNDPYUb8mAVrDIeXA1dqLafUA/G7xficseFzz2jw",
	"OYXYykB8jfGlZHlyrZqE3AM4EF3RI41QfJrKUhMI8IV25caNleWrJcT/3yP8hscMzsx1g15vup6N/+l4",
	"t5njFl12qm9jE2Rhp21OKWMWpDxJNC+NlAfiAV1o3iTXmZ80bGiLlXqjqhRqMIRYW1keAb9teD4zU9j7",
	"F+B+jVavpYvfC+zT1Fz5V+E/bng5f5fAt4rW1UFCBbNS0NFr/Tp6arqSM54bbmejpSTGqJCkveUM+50L",
	"ysUQISC6dKVJaFqiIsJ0kyh5D1k1XjumVirNq0mJAbOv1bLnkolB9ZhhtWV/m6yb1YxBpljehdItT+Ak",
	"UbYHIf4WXehDlHFpvZBZ1emElHJranJVhIwuv+hhOIYDYr5A9WcMh3X9ckcdDde2k20Zxf9AjoU3CBVs",
	"xAkjpzXE0xHBB+EYSSXVNnoAIZzS4wH0IYbTelEtVFm5KolyoCPM5l10cVOckfK3BCwdKi3pih5EiIYM",
	"/g81pSj1INS++u6b64pRZU1BHgc08SDLTuiaLkcdqjQ8dppmYlwG1prJ8rQwJrblrJ9Takb7P7E4Q4Q+",
	"oDSSM07xkJAQVNhQSshp25OjuoDEhKS3RFYE4cXaVxYb0RX7cCZnq6RvUnEuPna8CSuJKWaw6NL46pgS",
	"gG6yMRwkRozmWm8T7BkVp78ghBOxR6yH+dwT+zlC6murq1/Ppg79NnqVnDsR38kKQjCcazQNR47TykvI",
	"Gq78Qi6cVQ2RLc31QoBegRcwpHk8ElyaDPFVjZB7oiCWcuWIHmLuBDUNjuA4nXtIhEdwBoHoYplOUqkQ",
	"hA77Ya0kMZ8nzqtIxvz3H7dllp33KuH6KU9M+HylgJXgd7SaikgkHhDFBvK7RTlXZadAF1fkkQKKeYrn",
	"pq/V55PpQ0prLIbKfJquJaNAymBGicvE/mWX7XccNb/OG4Ucu6d8wyICG4o9OIAzClrKxnG9miD6GFr6",
	"ApUU7Fx3tVPTPyvc/isMxB7BQfanT8nTyocx7FzFbsJBQT3X+yrqnn8Pe7sAott2/gkAAP//Q3I0Tm4e",
	"AAA=",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %w", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	res := make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	resolvePath := PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		pathToFile := url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
